package test;
import static org.junit.Assert.*;
import static org.hamcrest.CoreMatchers.*;
import java.util.ArrayList;
import java.util.Iterator;
import java.util.List;
import kadai.TDUSet;
import kaitou.TDUIterator;

import org.junit.Before;
import org.junit.Test;
public class TDUIteratorTest {
	private Integer[] array3 = {9,1,2};
	private Integer[] array2 = {9,1,2,8,3,4,5,7,6};
	private Iterator<Integer> iterator1;
	private Iterator<Integer> iterator2;
	private Iterator<Integer> iterator3;
	@Before
	public void setUp() throws Exception {
		iterator1 = new TDUIterator<Integer>(new Integer[0]);
		iterator2 = new TDUIterator<Integer>(array2);
		iterator3 = new TDUIterator<Integer>(array3);
	}
	private <E> E[] toArray(Iterator<E> it){
		List<E> list = new ArrayList<E>();
		while(it.hasNext()){
			list.add(it.next());
		}
		@SuppressWarnings("unchecked")
		E[] array = (E[]) list.toArray();
		return array;
	}
	@Test
	public void testHasNext() {
		assertThat(iterator1.hasNext(),is(false));
	}
	@Test
	public void testTotal(){
		assertThat(iterator3.hasNext(),is(true));
		assertThat(iterator3.next().intValue(),is(9));
		assertThat(iterator3.hasNext(),is(true));
		assertThat(iterator3.next().intValue(),is(1));
		assertThat(iterator3.hasNext(),is(true));
		assertThat(iterator3.next().intValue(),is(2));
		assertThat(iterator3.hasNext(),is(false));
	}
	@Test
	public void testNext() {
		assertArrayEquals(new Integer[0],toArray(iterator1));
		assertArrayEquals(array2,toArray(iterator2));
	}
	@Test(expected=UnsupportedOperationException.class)
	public void testRemove(){
		iterator1.remove();
	}
}
