package test;
import java.util.Map;
import java.util.HashMap;
import java.util.TreeMap;
import kaitou.TDUMap;
public class TDUMapDemo {
	final private static int n = 10000;
	final private static int wordLength = 5;
	public static void main(String[] args) {
		@SuppressWarnings("unchecked")
		Map<String,Double>[] maps = (Map<String, Double>[])(new Map[]{
				new HashMap<String,Double>(),
				new TreeMap<String,Double>(),
				new TDUMap<String,Double>()
		});
		int k = (int)(Math.random() * maps.length);
		String[] testWords = generateStrings(n);
		double[] testDoubles = generateDouble(n);
		StopWatch sw = new StopWatch();
		test(maps[k],testWords,testDoubles);
		System.out.println(maps[k].getClass().getName()+":"+sw);
	}
	private static void test(Map<String, Double> m, String[] testWords,
			double[] testDoubles) {
		for(int i=0; i<testWords.length; i++){
			m.put(testWords[i], testDoubles[i]);
			m.entrySet();
		}
	}
	private static double[] generateDouble(int n2) {
		double[] result = new double[n2];
		for(int i=0 ; i<n2; i++){
			result[i]=Math.random();
		}
		return result;
	}
	private static String[] generateStrings(int n2) {
		String[] result = new String[n2];
		for(int i=0; i<n2; i++){
			result[i]=generateString(wordLength);
		}
		return result;
	}
	final private static String alphabets = "abcdefghijklmnopqrstuvwxyz";
	private static String generateString(int i) {
		StringBuilder result = new StringBuilder();
		for(int j=0; j<i; j++){
			result.append(alphabets.charAt((int)(Math.random()*alphabets.length())));
		}
		return result.toString();
	}
}
