package test;
import static org.junit.Assert.*;
import static org.hamcrest.CoreMatchers.*;
import java.util.Map;

import kadai.TDUMapEntry;
import kaitou.TDUMap;
import org.junit.Test;
public class TDUMapTest {
	@Test
	public void testSize() {
		Map<String, Double> m = new TDUMap<String,Double>(null);
		assertThat(m.size(),is(0));
		assertThat(m.size(),is(0));
		final TDUMapEntry<String,Double> e1 = new TDUMapEntry<String,Double>("abc",0.123);
		m = new TDUMap<String, Double>(e1);
		assertThat(m.size(),is(1));
		assertThat(m.size(),is(1));
		final TDUMapEntry<String, Double> e2 = new TDUMapEntry<String,Double>("def",0.456);
		e1.left=e2;
		m = new TDUMap<String, Double>(e1);
		assertThat(m.size(),is(2));
		assertThat(m.size(),is(2));
		final TDUMapEntry<String, Double> e3 = new TDUMapEntry<String, Double>("ghi",0.789);
		e1.right=e3;
		m = new TDUMap<String, Double>(e1);
		assertThat(m.size(),is(3));
		assertThat(m.size(),is(3));
		final TDUMapEntry<String, Double> e4 = new TDUMapEntry<String, Double>("jkl",0.12);
		final TDUMapEntry<String, Double> e5 = new TDUMapEntry<String, Double>("mno",0.345);
		final TDUMapEntry<String, Double> e6 = new TDUMapEntry<String, Double>("pqr",0.678);
		e2.left=e4;
		e2.right=e5;
		e3.right=e6;
		m = new TDUMap<String,Double>(e1);
		assertThat(m.size(),is(6));
		assertThat(m.size(),is(6));
	}
	@Test
	public void testEntrySet() {
		Map<String, Double> m = new TDUMap<String,Double>(null);
		assertEquals("[]",m.entrySet().toString());
		assertEquals("[]",m.entrySet().toString());
		final TDUMapEntry<String, Double> e1 = new TDUMapEntry<String, Double>("abc",0.123);
		m = new TDUMap<String,Double>(e1);
		assertEquals("[abc=0.123]",m.entrySet().toString());
		assertEquals("[abc=0.123]",m.entrySet().toString());
		final TDUMapEntry<String, Double> e2 = new TDUMapEntry<String, Double>("def",0.456);
		e1.left=e2;
		m = new TDUMap<String,Double>(e1);
		assertEquals("[def=0.456, abc=0.123]",m.entrySet().toString());
		assertEquals("[def=0.456, abc=0.123]",m.entrySet().toString());
		final TDUMapEntry<String, Double> e3 = new TDUMapEntry<String, Double>("ghi",0.789);
		e1.right=e3;
		m = new TDUMap<String,Double>(e1);
		assertEquals("[def=0.456, abc=0.123, ghi=0.789]",m.entrySet().toString());
		assertEquals("[def=0.456, abc=0.123, ghi=0.789]",m.entrySet().toString());
		final TDUMapEntry<String, Double> e4 = new TDUMapEntry<String, Double>("jkl",0.12);
		e2.left=e4;
		m = new TDUMap<String,Double>(e1);
		assertEquals("[jkl=0.12, def=0.456, abc=0.123, ghi=0.789]",m.entrySet().toString());
		assertEquals("[jkl=0.12, def=0.456, abc=0.123, ghi=0.789]",m.entrySet().toString());
		final TDUMapEntry<String, Double> e5 = new TDUMapEntry<String, Double>("mno",0.345);
		e2.right=e5;
		m = new TDUMap<String,Double>(e1);
		assertEquals("[jkl=0.12, def=0.456, mno=0.345, abc=0.123, ghi=0.789]",m.entrySet().toString());
		assertEquals("[jkl=0.12, def=0.456, mno=0.345, abc=0.123, ghi=0.789]",m.entrySet().toString());
		final TDUMapEntry<String, Double> e6 = new TDUMapEntry<String, Double>("pqr",0.678);
		e3.right=e6;
		m = new TDUMap<String,Double>(e1);
		assertEquals("[jkl=0.12, def=0.456, mno=0.345, abc=0.123, ghi=0.789, pqr=0.678]",m.entrySet().toString());
		assertEquals("[jkl=0.12, def=0.456, mno=0.345, abc=0.123, ghi=0.789, pqr=0.678]",m.entrySet().toString());
	}
	@Test
	public void testPut() {
		Map<String,Double> map = new TDUMap<String,Double>();
		assertEquals("[]",map.entrySet().toString());
		assertEquals(null,map.put("jkl",0.12));
		assertEquals("[jkl=0.12]",map.entrySet().toString());
		assertEquals(new Double(0.12),map.put("jkl",0.13));
		assertEquals("[jkl=0.13]",map.entrySet().toString());
		assertEquals(null,map.put("def",0.456));
		assertEquals("[def=0.456, jkl=0.13]",map.entrySet().toString());
		assertEquals(null,map.put("mno",0.345));
		assertEquals("[def=0.456, jkl=0.13, mno=0.345]",map.entrySet().toString());
		assertEquals(null,map.put("abc",0.123));
		assertEquals("[abc=0.123, def=0.456, jkl=0.13, mno=0.345]",map.entrySet().toString());
		assertEquals(null,map.put("ghi",0.789));
		assertEquals("[abc=0.123, def=0.456, ghi=0.789, jkl=0.13, mno=0.345]",map.entrySet().toString());
		assertEquals(null,map.put("pqr",0.678));
		assertEquals("[abc=0.123, def=0.456, ghi=0.789, jkl=0.13, mno=0.345, pqr=0.678]",map.entrySet().toString());
		assertEquals(new Double(0.13),map.put(new String("jkl"),0.901));
		assertEquals("[abc=0.123, def=0.456, ghi=0.789, jkl=0.901, mno=0.345, pqr=0.678]",map.entrySet().toString());
		assertEquals(null,map.put("ABC",0.456));
		assertEquals("[ABC=0.456, abc=0.123, def=0.456, ghi=0.789, jkl=0.901, mno=0.345, pqr=0.678]",map.entrySet().toString());
		assertEquals(new Double(0.456),map.put("def",0.234));
		assertEquals("[ABC=0.456, abc=0.123, def=0.234, ghi=0.789, jkl=0.901, mno=0.345, pqr=0.678]",map.entrySet().toString());
		assertEquals(new Double(0.345),map.put("mno",0.567));
		assertEquals("[ABC=0.456, abc=0.123, def=0.234, ghi=0.789, jkl=0.901, mno=0.567, pqr=0.678]",map.entrySet().toString());
	}
}
